﻿namespace HeuristicLab.BenchmarkSuite.Problems {
  using HeuristicLab.BenchmarkSuite.ERC;
  using HeuristicLab.Data;

  public class CountOdds : BenchmarkSuiteDataDescriptor {
    private const string name = "Count Odds";
    private const string fileName = "CountOdds.csv";
    private const string description = "";
    private readonly ExampleArgumentType[] inputArgumentTypes = { ExampleArgumentType.IntegerCollection };
    private readonly ExampleArgumentType[] outputArgumentTypes = { ExampleArgumentType.Integer };

    private readonly DataTypes enabledDataTypeses = DataTypes.Exec | DataTypes.Integer | DataTypes.Boolean | DataTypes.IntegerVector;
    private readonly ProblemErcOptions problemErcOptions = new ProblemErcOptions {
      IntegerErcRange = new ErcOptionRange<IntValue>(
        new IntValue(-1000),
        new IntValue(1000),
        new IntValue(0),
        new IntValue(1),
        new IntValue(2))
    };

    public override string Name { get { return name; } }
    public override string Description { get { return description; } }
    protected override string FileName { get { return fileName; } }
    public override ExampleArgumentType[] InputArgumentTypes { get { return inputArgumentTypes; } }
    public override ExampleArgumentType[] OutputArgumentTypes { get { return outputArgumentTypes; } }
    public override int OriginalTrainingCount { get { return 200; } }
    public override int OriginalTestCount { get { return 2000; } }
    public override int BestResult { get { return 0; } }
    public override int WorstResult { get { return 50; } }
    public override ProblemErcOptions ProblemErcOptions { get { return this.problemErcOptions; } }
    public override DataTypes EnabledDataTypes { get { return this.enabledDataTypeses; } }
    public override int MaxSize { get { return 500; } }
    public override int EvalLimit { get { return 1500; } }
    public override int MaxGenerations { get { return 300; } }
    public override int ProgEvalBudget { get { return 60000000; } }

    public override Example ParseExample(string[] input, string[] output) {
      return new Example {
        InputArgs = input,
        OutputArgs = output,
        InputInt = ExampleArgumentConverter.ConvertIntegers(input[0]),
        OutputInt = ExampleArgumentConverter.ConvertIntegers(output[0])
      };
    }
  }
}
